{
  $Id: stub.pas,v 1.3 2005/02/15 12:41:23 bert Exp $

  $Log: stub.pas,v $
  Revision 1.3  2005/02/15 12:41:23  bert
  *** empty log message ***

  Revision 1.2  2005/02/15 11:21:21  bert
  *** empty log message ***

}
unit stub;

interface
uses Windows, Winsock2, proxy_intf;

    function Stub_Bind (s : TSocket; const name: PSockAddr; namelen: integer): integer;
    function Stub_CloseSocket (s: TSocket): integer;
    function Stub_Connect (s: TSocket; const name: PSockaddr; namelen: integer): integer;
    function Stub_Recv(s: TSocket; Buf: Pointer; len, flags: Integer): Integer;
    function Stub_RecvFrom (s: TSocket; Buf: Pointer; len, flags: Integer; var from: TSockAddr; var fromlen: Integer): Integer;
    function Stub_Select (nfds: integer; readfds, writefds, exceptfds: PFDSet; timeout: PTimeval): integer;
    function Stub_Send (s: TSocket; Buf: Pointer; len, flags: Integer): Integer;
    function Stub_SendTo (s: TSocket; Buf: Pointer; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer;
    function Stub_SetSockOpt (s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer;
    function Stub_Shutdown (s: TSocket; how: integer): integer;
    function Stub_Socket (af: integer; type_: integer; protocol: integer): TSocket;
    function Stub_ioctlsocket ( const s: TSocket; const cmd: DWORD; var arg: u_long ): Integer;
    function Stub_getsockname ( const s: TSocket; var name: TSockAddr; var namelen: Integer ): Integer;

var
   UpcallIntf: TFreeCapIntf;
    
implementation
uses cfg, loger;

function Stub_Bind (s : TSocket; const name: PSockAddr; namelen: integer): integer;
var
   RetErr: DWORD;
begin
     result := UpcallIntf.WSockUpcall.pWSABind(s, name, namelen, @RetErr);
end;


function Stub_getsockname ( const s: TSocket; var name: TSockAddr; var namelen: Integer ): Integer;
var
   RetErr: DWORD;
begin
     result := UpcallIntf.WSockUpcall.pWSAGetSockName(s, @name, @namelen, @RetErr);
end;


function Stub_CloseSocket (s: TSocket): integer;
var
   RetErr: DWORD;
begin
     result := UpcallIntf.WSockUpcall.pWSACloseSocket(s, @RetErr);
end;

function Stub_Connect (s: TSocket; const name: PSockaddr; namelen: integer): integer;
var
   RetErr: DWORD;
   Dummy: LPWSABUF;
begin
     Dummy[0] := nil;
     result := UpcallIntf.WSockUpcall.pWSAConnect(s, name, namelen, Dummy, Dummy, nil, nil, @RetErr);
     if result <> ERROR_SUCCESS then
     begin
          SetLastError(RetErr);
          result := SOCKET_ERROR;
     end
end;

function Stub_Recv(s: TSocket; Buf: Pointer; len, flags: Integer): Integer;
var
   RetErr, RetVal, res: DWORD;
   Buffer: WSABUF;
   ThreadId: TWSATHREADID;
begin
     Buffer.len := len;
     Buffer.buf := Buf;
     ThreadId.ThreadHandle := GetCurrentThread();
     ThreadId.Reserved := 0;
     RetVal := UpcallIntf.WSockUpcall.pWSARecv (s, LPWSABUF(@Buffer), 1, @res,
         @flags, nil, nil, @ThreadId, @RetErr);

     if (RetVal = ERROR_SUCCESS) then
     begin
          if ((flags and MSG_PARTIAL) = 0) then
          begin
               result := integer(res);
               exit;
          end;
          RetErr := WSAEMSGSIZE;
     end;
     SetLastError(RetErr);
     result := SOCKET_ERROR;
end;

function Stub_RecvFrom (s: TSocket; Buf: Pointer; len, flags: Integer; var from: TSockAddr; var fromlen: Integer): Integer;
var
   RetErr, RetVal, res: DWORD;
   Buffer: WSABUF;
   ThreadId: TWSATHREADID;
begin
     Buffer.len := len;
     Buffer.buf := Buf;
     ThreadId.ThreadHandle := GetCurrentThreadId();
     ThreadId.Reserved := 0;

     RetVal := UpcallIntf.WSockUpcall.pWSARecvFrom (s, LPWSABUF(@Buffer), 1, @res,
         @flags, @from, @fromlen, nil, nil, @ThreadId, @RetErr);

     if (RetVal = ERROR_SUCCESS) then
     begin
          result := Integer(res);
          exit;
     end;

     SetLastError(RetErr);
     result := SOCKET_ERROR;
end;

function Stub_Select (nfds: integer; readfds, writefds, exceptfds: PFDSet; timeout: PTimeval): integer;
var
   RetErr: DWORD;
begin
     result := UpcallIntf.WSockUpcall.pWSASelect(nfds, readfds, writefds, exceptfds, timeout, @RetErr);
     if (result = SOCKET_ERROR) then
     begin
          SetLastError(RetErr);
          result := SOCKET_ERROR;
     end;
end;

function Stub_Send (s: TSocket; Buf: Pointer; len, flags: Integer): Integer;
var
   RetErr, res: DWORD;
   Buffer: WSABUF;
   ThreadId: TWSATHREADID;
begin
     Buffer.len := len;
     Buffer.buf := Buf;
     ThreadId.ThreadHandle := GetCurrentThreadId();
     ThreadId.Reserved := 0;

     result := UpcallIntf.WSockUpcall.pWSASend(s, LPWSABUF(@Buffer), 1, @res, flags, nil, nil, @ThreadId, @RetErr);
     if (result = ERROR_SUCCESS) then
     begin
          result := res;
          exit;
     end;
     SetLastError(RetErr);
     result := SOCKET_ERROR;
end;

function Stub_SendTo (s: TSocket; Buf: Pointer; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer;
var
   RetErr, res: DWORD;
   Buffer: WSABUF;
   ThreadId: TWSATHREADID;
begin
     Buffer.len := len;
     Buffer.buf := Buf;
     ThreadId.ThreadHandle := GetCurrentThreadId();
     ThreadId.Reserved := 0;

     result := UpcallIntf.WSockUpcall.pWSASendTo(s, LPWSABUF(@Buffer), 1,
         @res, flags, @addrto, tolen, nil, nil, @ThreadId, @RetErr);

     if (result = ERROR_SUCCESS) then
     begin
          result := res;
          exit;
     end;
     SetLastError(RetErr);
     result := SOCKET_ERROR;
end;

function Stub_SetSockOpt (s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer;
var
   RetErr: DWORD;
begin
     result := UpcallIntf.WSockUpcall.pWSASetSockOpt(s, level, optname, optval, optlen, @RetErr);
end;

function Stub_Shutdown (s: TSocket; how: integer): integer;
var
   RetErr: DWORD;
begin
     result := UpcallIntf.WSockUpcall.pWSAShutdown(s, how, @RetErr);
end;

function Stub_Socket (af: integer; type_: integer; protocol: integer): TSocket;
var
   RetErr: DWORD;
begin
     if @UpcallIntf.pAllocSocket <> nil then
       result := UpcallIntf.pAllocSocket(af, type_, protocol)
     else
       result := UpcallIntf.WSockUpcall.pWSASocket(af, type_, protocol, nil, 0, 0, @RetErr);

     if (result = INVALID_SOCKET) then
     begin
          Log(LOG_LEVEL_WARN, 'Stub_Socket error! Invalid socket!', []);
          result := INVALID_SOCKET;
     end;
end;

function Stub_ioctlsocket ( const s: TSocket; const cmd: DWORD; var arg: u_long ): Integer;
var
   DontCare, RetErr: DWORD;
   ThreadId: TWSATHREADID;
begin
     ThreadId.ThreadHandle := GetCurrentThreadId();
     ThreadId.Reserved := 0;

     result := UpcallIntf.WSockUpcall.pWSAIoctl(s, cmd, @arg, sizeof(u_long), @arg,
         sizeof(u_long), @DontCare, nil, nil, @ThreadId, @RetErr);

     if (result <> ERROR_SUCCESS) then
     begin
          SetLastError(RetErr);
          result := SOCKET_ERROR;
     end;
end;

end.
